// SLogic	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __APPWINDOW_H_
#define __APPWINDOW_H_

#include <util/message.h>
#include <util/string.h>
#include <util/resources.h>
#include <util/settings.h>
#include <util/messenger.h>

#include <gui/window.h>
#include <gui/toolbar.h>
#include <gui/button.h>
#include <gui/dropdownmenu.h>
#include <gui/filerequester.h>

#include "sidebar_componentlist.h"
#include "compdraw.h"
#include "tool_arrow.h"
#include "tool_connect.h"
#include "tool_hand.h"

class AppWindow : public os::Window
{
public:
	#define SIMULATION_TIMER 0

	AppWindow( const os::Rect& cFrame );
	~AppWindow();
	virtual void HandleMessage( os::Message* pcMessage );
	virtual void TimerTick( int nID );
	virtual bool OkToQuit( void );
	virtual void FrameSized( const os::Point& delta );

	Tool* GetCurrentTool() { return m_CurrentTool; };

	void RedrawComponent( Component* comp );

private:
	void Layout( bool force = false );

	// Toolbars
	os::ToolBar* m_Toolbar;

	// Tools
	Tool* m_CurrentTool;
	ToolArrow* m_ToolArrow;
	ToolConnect* m_ToolConnect;
	ToolHand* m_ToolHand;

	// Sidebars
	SideBar* m_CurrentSideBar;
	CompListSideBar* m_ComponentListSidebar;

	// Main drawing area
	CompDraw* m_ComponentDraw;
};

#endif /* __APPWINDOW_H_ */


