// SLogic	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "component_button.h"
#include "common.h"

using namespace os;

ComponentButton :: ComponentButton() : Component( LoadImage( "button.png" ), LoadImage( "button.png" ), "Switch", "Switch" )
{
	AddOutputPin( Point( 48, 23 ), "Q" );

	m_Switch = false;

	m_ActiveButton = LoadImage( "button_active.png" );
	m_ActiveButtonDrag = LoadImage( "button_active.png" );
	m_ActiveButtonDrag->ApplyFilter( Image::F_GRAY );
	m_DeactiveButton = LoadImage( "button.png" );
	m_DeactiveButtonDrag = LoadImage( "button.png" );
	m_DeactiveButtonDrag->ApplyFilter( Image::F_GRAY );
}


ComponentButton :: ~ComponentButton()
{
}

Component* ComponentButton :: Duplicate()
{
	return new ComponentButton();
}

bool ComponentButton :: GetOutputState( String name )
{
	if( name == "Q" )  // Update output
	{
		return m_Switch;
	}

	return false;
}

void ComponentButton :: Invoked()
{
	m_Switch = !m_Switch;

	if( m_Switch )
	{
		Component::SetImages( m_ActiveButton, m_ActiveButtonDrag );
	}
	else
	{
		Component::SetImages( m_DeactiveButton, m_DeactiveButtonDrag );
	}

	SetPinState( "Q", m_Switch );

	Redraw();	
}
