// SLogic	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __TOOL_CONNECT_H_
#define __TOOL_CONNECT_H_

#include <gui/point.h>
#include "tool.h"
#include "pin_io.h"


class ToolConnect : public Tool
{
public:
	ToolConnect();
	~ToolConnect();

	virtual void Init();

	virtual void SetCursor();

	virtual void MouseUp( CompDraw* draw, const os::Point& cPosition, uint32 nButtons );
	virtual void MouseDown( CompDraw* draw, const os::Point& cPosition, uint32 nButtons );
	virtual void MouseMove( CompDraw* draw, const os::Point& cPosition, uint32 nButtons );

private:
	bool m_bMouseDown;
	bool m_Dragging;
	bool m_HitDraw;
	os::Point m_cStartPoint;
	os::Point m_cLastPoint;

	os::Point m_cLastHitPoint;

	PinIO* m_HitPin_1;
	PinIO* m_HitPin_2;
};

#endif

